<?php

include('includes/global.php');
include_once('img_level.php');

ShowPage();

function ShowTeamList()
{  
  global $Config, $System, $User;
  
  echo('<h3>Seznam překladatelských týmů</h3>');
  echo('Týmy jsou seskupení překladatelů, kteří se hlásí k něčemu společnému jako např. WoW serveru, způsobu překladu, ke stejnému hernímu spolku, aj. Být členem týmu samo o sobě nemá žádný zásadní důsledek a spíše to může pomoci se lépe orientovat mezi překladateli někomu, kdo sestavuje export.<br/>');
  $DbResult = $System->Database->query('SELECT COUNT(*) FROM `Team`');
  $DbRow = $DbResult->fetch_row();
  $PageList = GetPageList($DbRow[0]);    

  echo($PageList['Output']);
  echo('<table class="BaseTable">');

  $TableColumns = array(
    array('Name' => 'Name', 'Title' => 'Jméno'), 
    array('Name' => 'URL', 'Title' => 'Webové stránky'), 
    array('Name' => 'LeaderName', 'Title' => 'Vedoucí'), 
    array('Name' => 'NumberUser', 'Title' => 'Počet členů'), 
    array('Name' => 'TimeCreate', 'Title' => 'Datum založení'), 
  );
  if($User->Licence(LICENCE_USER)) $TableColumns[] = array('Name' => '', 'Title' => 'Uživatelské akce');

  $Order = GetOrderTableHeader($TableColumns, 'NumberUser', 1);
  echo($Order['Output']);

  if(array_key_exists('search', $_GET)) $_SESSION['search'] = ' WHERE `Name` LIKE "%'.$_GET['search'].'%" OR `Description` LIKE "%'.$_GET['search'].'%"'; 
    else if(!array_key_exists('search', $_SESSION)) $_SESSION['search'] = '';
    if (array_key_exists('search', $_GET) and ($_GET['search'] == '')) $_SESSION['search'] = '';

    $DbResult = $System->Database->query('SELECT *, (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) AS `NumberUser`, (SELECT `Name` FROM `User` WHERE `User`.`ID`=`Team`.`Leader`) AS `LeaderName` FROM `Team` '.$_SESSION['search'].$Order['SQL'].$PageList['SQLLimit']);
    while($Team = $DbResult->fetch_assoc()) 
    {
      echo('<tr>'.
        '<td><a href="?action=team&amp;id='.$Team['Id'].'">'.$Team['Name'].'</a></td>'.
        '<td><a href="http://'.$Team['URL'].'">'.$Team['URL'].'</a></td>'.
        '<td>'.$Team['LeaderName'].'</td>'.
        '<td><a href="userlist.php?team='.$Team['Id'].'" title="Zobrazit členy týmu">'.$Team['NumberUser'].'</a></td>'.
        '<td>'.HumanDate($Team['TimeCreate']).'</td>');
      if($User->Licence(LICENCE_USER))
      {
        if($Team['Leader'] == $User->Id) $Action = ' <a href="?action=modify&amp;id='.$Team['Id'].'">Upravit</a>'; 
          else $Action = '';
        if($Team['Id'] == $User->Team) $Action = ' <a href="?action=leave">Opustit</a>'; 
        echo('<td><a href="?action=gointeam&amp;id='.$Team['Id'].'">Vstoupit</a>'.$Action.'</td>');
      }
    echo('</tr>');
    }
    echo('</table>');
    echo($PageList['Output']);
    
    if($User->Licence(LICENCE_USER)) echo('<br /><div style="text-align: center;"><a href="?action=create">Vytvořit překladatelský tým</a></div>');
}          

function TeamJoin()
{
  global $System, $User;
  
  if($User->Licence(LICENCE_USER))
  {   
    if(array_key_exists('id', $_GET))
    { 
      $System->Database->query('UPDATE `User` SET `Team` = '.$_GET['id'].' WHERE `ID` = '.$User->Id); 
      ShowMessage('Vstoupil jsi do týmu.');    
      WriteLog('Uživatel vstoupil do týmu '.$_GET['id'], LOG_TYPE_USER);

      // Delete all teams without users
      $System->Database->query('DELETE FROM `Team` WHERE (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) = 0');
        
      // Set new leader for teams where old leader went to other team
      $System->Database->query('UPDATE `Team` SET `Leader`=(SELECT `Id` FROM `User` WHERE `User`.`Team`=`Team`.`Id` ORDER BY `User`.`RegistrationTime` LIMIT 1) WHERE `Leader` NOT IN (SELECT `ID` FROM `User` WHERE `User`.`Team`=`Team`.`Id`);');
        
      ShowTeamList();
    } else ShowMessage('Nutno zadat id týmu.', MESSAGE_CRITICAL);
  } else ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
}

function TeamCreateFinish()
{
  global $System, $User;
  
  if($User->Licence(LICENCE_USER))
  {   
    if(array_key_exists('Name', $_POST) and array_key_exists('Description', $_POST))
    {
      $DbResult = $System->Database->query('SELECT COUNT(*) FROM `Team` WHERE `Name` = "'.trim($_POST['Name']).'"');  
      $DbRow = $DbResult->fetch_row();
      $Count = $DbRow[0];
      if(($Count == 0) and ($_POST['Name'] != ''))
      {
        $System->Database->query('INSERT INTO `Team` (`Name` ,`Description`, `URL`, `TimeCreate`,`Leader`) VALUES ("'.trim($_POST['Name']).'", "'.trim($_POST['Description']).'", "'.$_POST['URL'].'", NOW(), '.$User->Id.')');  
        $System->Database->query('UPDATE `User` SET `Team` = '.$System->Database->insert_id.' WHERE `ID` = '.$User->Id); 
        ShowMessage('Překladatelský tým vytvořen.');
        WriteLog('Překladatelský tým vytvořen '.$_POST['Name'], LOG_TYPE_USER);

        // Delete all teams without users
        $System->Database->query('DELETE FROM `Team` WHERE (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) = 0');    
      } else ShowMessage('Již existuje tým se stejným jménem', MESSAGE_CRITICAL);
    } else ShowMessage('Chybí údaje formuláře', MESSAGE_CRITICAL);
  } else ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
  ShowTeamList();
}

function TeamModify()
{
  global $System, $User;
  
  if($User->Licence(LICENCE_USER))
  {   
    if(array_key_exists('id', $_GET))
    {
      $DbResult = $System->Database->query('SELECT * FROM `Team` WHERE `Id`='.$_GET['id'].' AND `Leader`='.$User->Id);
      if($DbResult->num_rows > 0)
      {
        $Team = $DbResult->fetch_assoc();
        echo('<form action="?action=finish_modify&amp;id='.$_GET['id'].'" method="post">'.
      '<fieldset><legend>Nastavení týmu</legend>'.
      '<table><tr><td>Jméno:</td><td><input type="text" name="Name" value="'.$Team['Name'].'"/></td></tr>'.
      '<tr><td>Webové stránky:</td><td>http://<input type="text" name="URL" value="'.$Team['URL'].'"/></td></tr>'.
      '<tr><td>Popis:</td><td><input type="text" name="Description" value="'.$Team['Description'].'"/></td></tr>'.
      '<tr><td colspan="2"><input type="submit" value="Uložit" /></td></tr>'.
      '</table></fieldset></form>');
      } else ShowMesage('Tým nenalezen.', MESSAGE_CRITICAL);
    } else ShowMessage('Nezadáno id týmu', MESSAGE_CRITICAL);
  } else ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
}

function TeamModifyFinish()
{
  global $System, $User;
  
  if($User->Licence(LICENCE_USER))
  {   
    if(array_key_exists('id', $_GET) and array_key_exists('Name', $_POST) and array_key_exists('Description', $_POST) and array_key_exists('URL', $_POST))
    {
      $DbResult = $System->Database->query('SELECT * FROM `Team` WHERE `Id`='.$_GET['id'].' AND `Leader`='.$User->Id);
      if($DbResult->num_rows > 0)
      {
        $Team = $DbResult->fetch_assoc();
        $DbResult = $System->Database->query('SELECT COUNT(*) FROM `Team` WHERE `Name` = "'.trim($_POST['Name']).'"');  
        $DbRow = $DbResult->fetch_row();
        $Count = $DbRow[0];
        if(($Count == 0) and ($_POST['Name'] != ''))
        {          
          $System->Database->query('UPDATE `Team` SET `Name`="'.$_POST['Name'].'", `Description`="'.$_POST['Description'].'", `URL`="'.$_POST['URL'].'" WHERE Id='.$Team['Id']);
          ShowMessage('Nastavení týmu uloženo.');
          WriteLog('Překladatelský tým upraven '.$_POST['Name'], LOG_TYPE_USER);
        } else ShowMessage('Již existuje tým se stejným jménem.', MESSAGE_CRITICAL);
      } else ShowMessage('Tým nenalezen nebo nemáte oprávnění.', MESSAGE_CRITICAL);
    } else ShowMessage('Nezadáno id týmu nebo některé položky formuláře.', MESSAGE_CRITICAL);
  } else ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
  ShowTeamList();
}

function TeamCreate()
{
  global $User;
  
  if($User->Licence(LICENCE_USER))
  {   
    echo('<form action="?action=finish_create" method="post">'.
    '<fieldset><legend>Vytvoření nového týmu</legend>'.
    '<table><tr><td>Jméno:</td><td><input type="text" name="Name" /></td></tr>'.
    '<tr><td>Webové stránky:</td><td>http://<input type="text" name="URL" value=""/></td></tr>'.
    '<tr><td>Popis:</td><td><input type="text" name="Description" /></td></tr>'.
    '<tr><td colspan="2"><input type="submit" value="Vytvořit a vstoupit" /></td></tr>'.
    '</table></fieldset></form>');
  } else ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
}

function TeamShow()
{
  global $System, $TranslationTree, $User, $Config;
  
  if(array_key_exists('id', $_GET) and is_numeric($_GET['id']))
  { 
    ImgLevelUpdate();
      
    $DbResult = $System->Database->query('SELECT *, (SELECT COUNT(*) FROM `User` WHERE `Team` = `Team`.`Id`) AS `NumberUser`, (SELECT SUM(`TranslatedCount`) FROM `User` WHERE `team` = `Team`.`Id`) AS `NumberTranslate` FROM `Team` WHERE `Id`='.$_GET['id']);
    if($DbResult->num_rows > 0)
    {
      $Team = $DbResult->fetch_assoc();
      $DbResult2 = $System->Database->query('SELECT `Name` FROM `User` WHERE `ID`='.$Team['Leader']);
      if($DbResult2->num_rows > 0) 
      {
        $Leader = $DbResult2->fetch_assoc();
        $Leader = $Leader['Name'];
      } else $Leader = '';
    
      echo('<strong>Překladatelský tým '.$Team['Name'].'</strong><br />'.
        'Webové stránky: <a href="http://'.$Team['URL'].'">'.$Team['URL'].'</a><br/>'.
        'Vedoucí: <strong>'.$Leader.'</strong><br/>'.
      $Team['Description'].'<br /><br />');
      //echo('<a href="export/?team='.$Team['Id'].'">Exportovat překlad týmu</a> ');
      if($User->Licence(LICENCE_USER)) echo('<a href="?action=gointeam&amp;id='.$Team['Id'].'">Vstoupit do týmu</a><br /><br />');
      echo('<fieldset><legend>Statistika</legend>'.
        'Počet členů týmu: <a href="userlist.php?team='.$Team['Id'].'" title="Zobrazit členy týmu">'.$Team['NumberUser'].'</a><br />'.
        'Počet přeložených textů týmu: <strong>'.$Team['NumberTranslate'].'</strong><br />'.
        'Průměrná úroveň překladatelů v týmu: <img src="tmp/team/'.$Team['Name'].'/level.png" /><br /><br />'.
        '<strong>Stav dokončení týmu pro verzi '.$Config['Web']['GameVersion'].'</strong><br />');

  $BuildNumber = GetBuildNumber($Config['Web']['GameVersion']);

  $GroupListQuery = 'SELECT `Group`.* FROM `Group`';
  $Query = '';
  $DbResult = $System->Database->query($GroupListQuery);
  while($DbRow = $DbResult->fetch_assoc())
  {
    $Query .= 'SELECT (SELECT COUNT(DISTINCT(`Entry`)) FROM ('.
    ' SELECT `T`.* FROM `'.$DbRow['TablePrefix'].'` AS `T`'.
    ' WHERE (`User` IN (SELECT `ID` FROM `User` WHERE `Team` = '.$Team['Id'].')) AND (`Complete` = 1) AND (`T`.`Language`!=0) AND (`VersionStart` <= '.$BuildNumber.') AND (`VersionEnd` >= '.$BuildNumber.')'.
    ') AS `C1`) AS `Translated`, '.
    '(SELECT COUNT(DISTINCT(`Entry`)) FROM ('.
    ' SELECT `T`.* FROM `'.$DbRow['TablePrefix'].'` AS `T`'.
    ' WHERE (`Language` = 0) AND (`VersionStart` <= '.$BuildNumber.') AND (`VersionEnd` >= '.$BuildNumber.')'.
    ') AS `C2`) AS `Total`, "'.$DbRow['Name'].'" AS `Name` UNION ';
  }
  $Query = substr($Query, 0, - 6);

  $DbResult = $System->Database->query('SELECT COUNT(*) FROM ('.$GroupListQuery.') AS `T`');
  $DbRow = $DbResult->fetch_row();
  $PageList = GetPageList($DbRow[0]);  
  echo($PageList['Output']);
  
  echo('<table class="BaseTable">');
  $TableColumns = array(
    array('Name' => 'Name', 'Title' => 'Jméno'), 
    array('Name' => 'Translated', 'Title' => 'Přeložených'), 
    array('Name' => 'Total', 'Title' => 'Anglických'), 
    array('Name' => 'Percent', 'Title' => 'Procenta'), 
  );

  $Order = GetOrderTableHeader($TableColumns, 'Name', 0);
  echo($Order['Output']);

  $Translated = 0;
  $Total = 0;
  $DbResult = $System->Database->query('SELECT *, ROUND(`Translated` / `Total` * 100, 2) AS `Percent` FROM ('.$Query.') AS `C3` '.$Order['SQL'].$PageList['SQLLimit']);
  while($Group = $DbResult->fetch_assoc()) 
  {
    echo('<tr><td>'.$Group['Name'].'</td><td>'.$Group['Translated'].'</td><td>'.$Group['Total'].'</td><td>'.ProgressBar(150, $Group['Percent']).'</td></tr>');
    $Translated += $Group['Translated'];
    $Total += $Group['Total'];
  }
  echo('<tr><td><strong>Celkem</strong></td><td><strong>'.$Translated.'</strong></td><td><strong>'.$Total.'</strong></td><td><strong>'.ProgressBar(150, round($Translated / $Total * 100, 2)).'</strong></td></tr>');
  echo('</table>');
  
      echo('</fieldset>');    
    } else ShowMessage('Tým nenalezen', MESSAGE_CRITICAL);
  } else ShowMessage('Musíte zadat id týmu', MESSAGE_CRITICAL);
}

function TeamLeave()
{
  global $System, $User;
  
  if($User->Licence(LICENCE_USER))
  {   
    $System->Database->query('UPDATE `User` SET `Team` = 0 WHERE `ID` = '.$User->Id); 
    ShowMessage('Nyní nejste členem žádného týmu.');    
    WriteLog('Uživatel vystoupil z týmu', LOG_TYPE_USER);

    // Delete all teams without users
    $System->Database->query('DELETE FROM `Team` WHERE (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) = 0');
        
    // Set new leader for teams where old leader went to other team
    $System->Database->query('UPDATE `Team` SET `Leader`=(SELECT `Id` FROM `User` WHERE `User`.`Team`=`Team`.`Id` ORDER BY `User`.`RegistrationTime` LIMIT 1) WHERE `Leader` NOT IN (SELECT `ID` FROM `User` WHERE `User`.`Team`=`Team`.`Id`);');
        
    ShowTeamList();
  } else ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
}

if(array_key_exists('action', $_GET))
{
  if($_GET['action'] == 'gointeam') TeamJoin();
  else if($_GET['action'] == 'finish_create') TeamCreateFinish();
  else if($_GET['action'] == 'modify') TeamModify();
  else if($_GET['action'] == 'finish_modify') TeamModifyFinish();
  else if($_GET['action'] == 'create') TeamCreate();
  else if($_GET['action'] == 'team') TeamShow();
  else if($_GET['action'] == 'leave') TeamLeave();
  else ShowTeamList();
} else ShowTeamList();

ShowFooter();      

?>
